--[[

Version 2.0 - Initial release of WotLK Branch to WowAce SVN

New Author : Levva of EU Khadgar - by kind Permission of Disquette

Renamed to ShockAndAwe (based on orginal DisqoDice by Disquette)

Completely overhauled for WotLK.
 - Updated to use Ace3
 - Removed totem twisting as not available in WotLK
 - Added bar for Maelstrom Weapon stacks
 - revamped bar timings so that talents taken into account
    - now uses Imp.SS talent to reduce SS cooldown
    - still manual config of 4 piece Arena bonus (on TODO list to automate this)
    - uses Maelstrom talents to determine whether to show maelstrom bar
    - now honors talents in Reverberation to adjust cooldown timer on Shock bar
    - added initial start at config window on blizzard config panel (well it has an about so far!!)

Version 2.01 -
	Enabled the /dqd & /disqodice config options 
	Added confirmation text when an option was used
	
Version 2.02 -
	Fixed display and moving bars options not showing frames after moved
	Fixed turning maelstrom on and off not comming back on
	
Version 2.10 - 
	Decided to change addon name to ShockAndAwe
	Added drycoded support for Lava Burst timer bar
	Refreshed WS code to be Shield code - added text support for Shields
	Added text support for Wind Shock
	Added check for Shamanistic Focus up
	Fixed respeccing issue
	Changed Maelstrom to show 15 sec cooldown - now hidden out of combat, pale in combat and lights up with 5 charges.
	Added text indicator on Maelstrom bar to show how many stacks
	Added text on shield indicator to show how many orbs
	Added icon to shock bar to show if Shamanistic Focus buff present - not working
	Fixed typo preventing SavedVariables actually saving between sessions
	Added text on shock bar to show if Shamanistic Focus has procced
	Altered bar height so that if you choose to show less bars then the spacing changes - eliminates gaps for non shown bars
        - this may need code to check if spacing is still valid if user turns on or off showing a bar during session
	
Version 2.11
	Changed width of SS to be full frame width and adjusted Shock & WFProc to proportional widths
	Fixed issue of maelstrom bar not showing after having moved frame
	
Version 2.12
	Added config tab for Uptime 
	Radical overhaul of the shield frame so that it consistently updates after zoning/reloading etc.
	
Version 2.13 
	Added version info
	Added Uptime Frame 
	Changed display to moveframes and updated background when in moving mode to make it more obvious
	Uptime Frames now show initial attempt at uptimes of various buffs - lots of testing still required
		- session time bars displaying 
		- last fight ones go wrong after second fight though - TODO
		- no icons displaying - TODO
		
Version 2.14 
	Fixed icon files for uptime frames and Shamanistic Focus
	Fixed last fight uptimes showing >100%
	Added tooptip to uptime frame
	
Version 2.15
	added startup to disable addon if not a shaman
	
Version 2.20 
	Removed Shamanistic Focus icon as build 8926 has it as passive ability 
	Added earth shock/flame shock rotation display icon
	Added wind shock threat threshold warning - tested with help from Isbeorn on Coldarra beta server
	Fixed issue with lastfight buff times being summed incorrectly (was a cut n paste error)
	Lots and lots of tweaking of config options for bars - still needs idiot proof testing though
	TODO - Reset option - make sure it resets all bar values
	
Version 2.21 
	Fixed debug info for windshock spamming chat when in a party
	Added config option to disable showing of uptime frame
	Added config option to disable showing text on bars
	Fixed Maelstrom weapon & Imp SS talents which had moved in build 8970
	
Version 2.22
	Localised more strings
	
Version 2.30
	Added Lava Lash CD bar
	Added Lava Burst CD bar
	Changed check for Flame Shock on target to check that its mine
	Added AceGUI-3.0 dependency
	
Version 2.40
	Fixed Wind Shock colour to dark gray similar to WS icon
	Added icon on Maelstrom Weapon bar to show LB or LvB depending on cooldowns etc.
	Added temp fix for Maelstrom Talents not being seen on login
	
Version 2.41
	Upped Windshock alpha so its easier to see
	
Version 2.50 
	Added support for SharedMedia
	
Version 2.51
	Fixed Lava Lash not showing bug
	
Version 2.52 
	Updated MW cooldown time to 30 sec as per build 9014
	Fixed bug if bar was not showing on load it would display in wrong place when activated during game
	
Version 2.60 
	Added Options to pick your own colour scheme for all the bars
	
Version 2.61
	Removed Lava Burst icon display from 5 stack of MW
	
Version 2.62
	Finally worked out syntax to have project work on new Curseforge.com SVN so revision now uses CF revision numbers
	this also means I can simply tag a version as release and it automatically appears on Curse.com website.
	
Version 2.63 
	Swapped order of Shock and Lava Lash bar so order is Shield, MW, SS, Shock, LL - which pretty much matches priority queue
	Added option to hide shield bar if its active - so that you only see it if it needs refreshing.
	
Version 2.64
	Added no-lib stripping and optionaldeps

Version 2.70 
	Added option to set border textures
	Added option to set font on frames
	Moved various options around and re-ordered the menus
	Massive overhaul of the Uptime frame - fixed a couple of memory leaks - should run a lot faster and a lot less memory
	Added option to configure uptime frame colours
	
Version 2.71
	Added German translations thanks to Bekeon on wowinterface.com
	Fixed rescaling issue
	
Version 2.80
	Added a global cooldown bar which auto-adjusts for any haste effects

Version 2.81
	Fixed spark point to no longer be offset by its width on GCD bar
	
Version 2.82 
	Fixed GCD bar visible by default on entering world
	Fixed missing French localisation entries (still needing translation)
	
Version 2.90 
	Added optional sound to play when 5 stacks of Maelstrom Weapon are achieved
	Uses any sound registered with SharedMediaLib
	Add option to flash Maelstrom Weapon frame when you get 5 stacks
	
Version 2.91
	Fixed lava lash bar bug when you turn the option on
	Added additional sound options
	Added option to play sound on 4 stacks of MW
	Added option to vary time between sounds of 5 MW stacks
	
Version 2.92
	Fixed some French translations thanks to Phops Illidan(EU) 
	Should now fully work on French Client
	
Version 2.93
	Fixed bug with turning on and off MW4 sound option
	
Version 3.00
	Remove Lava Burst bar
	Tidy up command line config menus and add a help message to direct to Blizzard config options
	Clarified how scaling works by updating help message
	Fixed typo in setting bar textures
	Split options, uptime & stats off into separate lua files for easier maintenance
	Add support for recording WF & SS total dmg and displaying in Scrolling Combat Text (if installed)
	
Version 3.01
	Fixed sparkpoint for gcdbar being wrong place if bar width changed
	Fix width of bar frame when bar width changed
	
Version 3.02 
	Stopped mw5 stack sound playing if you are no longer in combat
	Removed rotation and maelstrom weapon icons options
	
Version 3.10
	Add priority frame
	Added options to select priorities - doesnt actually get used yet
	Using fixed MW5_LB, SS, ES, LL rotation hardcoded at present
	Changed GCD bar to narrower one so its easier to see how its timeout relates to other bars
	Fixed Maelstrom bar not showing sometimes after LB cast at 5 stacks
	Fixed Alpha of Maelstrom bar wrong after 5 stacks if you have flashing on
	Added option to disable Windfury bar
	Added display of Windshock icon in priority if threat is above threshold 
	Moved Windshock option & threat option to priority section
	
Version 3.11
	Added option to control when priority shows ie: within X seconds of cooldown expiry
	Allow priority to show when time left on cooldown is less than the user set cooldown period
	The priority options menu now works - you can now set your own priorities
	
Version 3.20
	Added option to keybind Watershield and Lightning Shield
	
Version 3.21
	Priority frame does actually hide now if you choose to disable it
	Priority frame now hides when out of combat
	Fixed an issue with DE translations that would have crashed the addon on using config options
	Added options to warn if shield or weapon imbues are down
	NB. Anyone asking for Rockbiter to be included will have their name added to the list of people the addon will refuse to work for
	Fixed issue with DE & FR localisations where Stormstrike, Lava Lash, Earth Shock & Flame Shock were listed twice in 
		localisation file once in local language and once in English - thus random as to whether which it used and if it broke
	Fixed bug on priority frame if it couldn't understand spell name now forces none to prevent error messages
	Fixed chain lightning priority to check if it is off cooldown
	Fixed show of uptime & priority frames for moving and rehiding when using /saa moveframes
	Added option to rebuff weapons with selected main hand/off hand buffs (still needs work - disabled in release version for now)
	Added options for warnings if shield down or weapon buffs expire - code not implemented yet
	
Version 3.30beta1
	Added sound for shield expiry - needs proper testing and more sounds
	Added keybinds for mh & oh enchants
	Added option to change font effects
	Added option to hide priority frame title
	Added msg frame to use for wf combos if no sct installed - not working but does print in chat for now
	Added command to display paper doll stats for export to EnhSim 
		- very early version - no cut n paste yet - limited data - no warnings about buffs 
	Added News frame to show important changes from one version to another.
		- first news article is only Hello World
	Fixed moving frames showing priority and uptime frames despite option to disable them
	Since the msg frame isn't working the loss of a weapon buff only reports to chat at present
	Warning when enchants expire - not working
	Warning when enter combat without weapon buffs not working
	
Version 3.30beta2
	Fixed export routine to export EnhSim data (first pass at this - I need to know of problems)
	Added warning if you have active buffs that MIGHT affect stats and thus the sim
	
Version 3.30beta3
	Fixed MW stacks sometimes not showing
	
Version 3.30
	Added Russian Localisations
	Fixed Weapon Rebuffs keybindings - still asks for confirmation if you overwrite one though
	Fixed playing sound if shield expires
	Added a few more sound choices
	Fixed Warning of missing weapon buff on entering combat 
	Fixed Message Frame - now visible and moveable
	Added options to set timeout for text on for message frame
	Added option to set colour for text on message frame
	
Version 3.31
	Fixed msgFrame not being movable using the moveframes option
	Added option to hide timer bars out of combat
	Export to EnhSim now adds the 1% heroic presence buff if you are Draenai to save you having to remember
	Fixed having accidentally undone the MW not showing after 5 fix
	Replaced code dealing with trinkets & totems to use an itemID lookup to get string - fixes localised names
	
Version 3.40
	Removed leftover debug code from export routine
	Fixed error msg bug if you clicked Accept on export 
	New option to show Shamanistic Rage icon when mana below a configurable percentage (10% by default)
	Added option to show Windshock icon for World Bosses only
	Updated Export routine to include Spirit, Max_mana, MP5, race, and weapon type - for sim v1.4.2 onwards
	Removed bonus on export stats if player alliance as sim now handles this
	Added command /saa config to open graphical config window
	
Version 3.41
	Fixed localisation issues with Russian and French locale files thanks to cranium_dc and Phops - Illidan (EU)
		- can users who use locale's outside enUS please check these files so that I know they work, thanks.
		- I am unable to check them myself because I have no non english client and I wouldn't understand the 
		- language anyway. Je m' comprende le Francaise peu t'etre. 
		- (I know thats probably wrongly spelt my French is limited to spoken, and a limited vocabulary at that.) 
	Fixed bug that priority wouldn't show Maelstrom weapon if the maelstrom weapon bar was switched off
	
Version 3.50
	Fixed priority bug where Wind Shock & Shamanistic Rage showed even when on cooldown
	Fixed export bug where MP5 value was not exporting as an integer
	Added detection for meta gems in export routine
	Added detection for weapon dps using LibGratuity in export routine
	Added a combo point frame to the Priority point frame to show MW stacks
	Priorty Frame shows blue border if Feral Spirits available
	
Version 3.60
	Fixed export missing out unrelenting storm
	Fixed weapon rebuff warning that buff has expired when rebuffing weapon
	Added option to display an icon on each bar to make it easier to work out which bar is which
	Added button to uptime frame to reset session values
	Fixed bug with uptime frame crashing if you reset its position
	Added a Wall of Text to the news frame 
	
Version 3.61
	Added Scrollbar to News frame so it should be visible even on the most pathetic of screen resolutions
	-  Seriously folks tick the box in video settings called Use UI Scale and move the bar towards low end.
	-  You are significantly penalising your screen size by not doing this
	
Version 3.62
	Removed testing setup which always showed News Frame
	Fixed icons always showing on timer bars
	
Version 3.63	
	News frame now closes on pressing ESC
	Weapon DPS export will now give zero if it doesn't find a numeric match - should fix localisation issues
	Added glyph detection to Export routine
	
Version 3.64
	Modified DPS check for German & French clients to use 100,3 dps instead of 100.3 dps (ie: comma not dot)
	Added extra checks to priority display to check if player has Wind Shock, Shamanistic Rage & Feral Spirit
	
Version 3.65
	Added a check to GCD bar to ensure that being unable to find Lightning Shield doesn't throw error
	
Version 3.70
	Added a Feral Spirit Bar with dual cooldowns - 3 min CD for ability and 45 second CD for wolves being out
	
Version 3.71
	Added a check on all priorities to catch situation where player has added an item to priority but hasn't
	learned that skill!!
	
Version 3.72
	Small fix to initialise Export routine & check for missing glyphs
	Leave Feral Spirit active bar visible outside combat if they are still active.	
	
Version 3.80
	Added readme.txt file as cut n paste of news.
	New features coded but not working 
	-	Added totem as option to priority list
	-	It will show generic totem icon if you select totem and time left < configured time (default 20 sec) and have no totems active
	-	Otherwise it will show icon of last totem dropped for that element
	-	Added macros for weapon rebuffing instead of just casting buff. Trying to get rid of "do you want to replace" messages
	Forced MsgFrame to be background should fix non click through issue
	Added explicit check when weapon enchant event fires to check the enchant status to prevent supurious expiry messages
	Fixed export routine's weapon dps bug - in doing so removed dependency on LibGratuity-3.0
	Updated export routine to match trinkets/totems/metagems/enchants used in EnhSim v1.4.8
	Fixed Shamanistic Rage option setting which was just crashing if you attempted to change the default
	
Version 3.81
	Fixed the tooltip help message displayed when setting Maelstrom Alpha & Full Alpha 
	Showing Shamanistic Rage or Wind Shock icon should no longer "lock" in place even when mana returned or threat reduced
	
Version 3.82
	Added Spanish Localisation provided by roMZell
	
Version 3.83
	Added Traditional Chinese Localisation provided by aletheia301 on Curse.com
	
Version 3.90
	Added Earth Shock only if Stormstrike debuff on target priority option 
	- Exisiting users will need to change their settings to include this option. New default is set to mw5_lb, es_ss, ss, es, ll
	
Version 3.91 
	Added out of range/too far away warning
	removed single use local variables for spell names
	added DebugPrint function
	
--]]

if select(2, UnitClass('player')) ~= "SHAMAN" then
	DisableAddOn("ShockAndAwe")
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("ShockAndAwe")
local AceAddon = LibStub("AceAddon-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
ShockAndAwe = AceAddon:NewAddon("ShockAndAwe", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local SCT = SCT
local REVISION = tonumber(("$Revision: 140 $"):match("%d+"))

ShockAndAwe.constants = {}
local C = ShockAndAwe.constants -- Defined in ShockAndAwe LUA no locale needed.

C["Stormstrike"], _, C["Stormstrike Icon"] = GetSpellInfo(32176)
C["Windfury Attack"], _, C["Windfury Attack Icon"] = GetSpellInfo(25584)
C["Frost Shock"], _, C["Frost Shock Icon"] = GetSpellInfo(49236)
C["Earth Shock"], _, C["Earth Shock Icon"] = GetSpellInfo(49231)
C["Flame Shock"], _, C["Flame Shock Icon"] = GetSpellInfo(49233)
C["Wind Shock"], _, C["Wind Shock Icon"] = GetSpellInfo(57994)
C["Lava Lash"], _, C["Lava Lash Icon"] = GetSpellInfo(60103)
C["Maelstrom Weapon"], _, C["Maelstrom Weapon Icon"] = GetSpellInfo(51532)
C["Water Shield"], _, C["Water Shield Icon"] = GetSpellInfo(33736)
C["Lightning Shield"], _, C["Lightning Shield Icon"] = GetSpellInfo(49281)
C["Earth Shield"], _, C["Earth Shield Icon"] = GetSpellInfo(49284)
C["Elemental Devastation"], _, C["Elemental Devastation Icon"] = GetSpellInfo(29178)
C["Flurry"], _, C["Flurry Icon"] = GetSpellInfo(16284)
C["Unleashed Rage"], _, C["Unleashed Rage Icon"] = GetSpellInfo(30807)
C["Windfury Weapon"], _, C["Windfury Weapon Icon"] = GetSpellInfo(58804)
C["Flametongue Weapon"], _, C["Flametongue Weapon Icon"] = GetSpellInfo(58790)
C["Frostbrand Weapon"], _, C["Frostbrand Weapon Icon"] = GetSpellInfo(58796)
C["Lightning Bolt"], _, C["Lightning Bolt Icon"] = GetSpellInfo(49238)
C["Chain Lightning"], _, C["Chain Lightning Icon"] = GetSpellInfo(49271)
C["Heroic Presence"], _, C["Heroic Presence Icon"] = GetSpellInfo(28878)
C["Shamanistic Rage"], _, C["Shamanistic Rage Icon"] = GetSpellInfo(30823)
C["Feral Spirit"], _, C["Feral Spirit Icon"] = GetSpellInfo(51533)
C["Healing Wave"], _, C["Healing Wave Icon"] = GetSpellInfo(49273)
C["Chain Heal"], _, C["Chain Heal Icon"] = GetSpellInfo(55459)

ShockAndAwe.frames = {}

ShockAndAwe.BaseFrame = CreateFrame("Frame","ShockAndAweBase",UIParent)
ShockAndAwe.frames["Maelstrom"] = CreateFrame("Frame","SAA_Bar1_Status", ShockAndAwe.BaseFrame) 
ShockAndAwe.frames["Maelstrom"].icon = CreateFrame("Frame","SAA_Bar1_StatusIcon",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["Stormstrike"] = CreateFrame("Frame","SAA_Bar2_Status",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["Stormstrike"].icon = CreateFrame("Frame","SAA_Bar2_StatusIcon",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["Shock"] = CreateFrame("Frame","SAA_Bar3_Status",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["Shock"].icon = CreateFrame("Frame","SAA_Bar3_StatusIcon",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["Windfury"] = CreateFrame("Frame","SAA_Bar4_Status",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["Shield"] = CreateFrame("Frame","SAA_Bar5_Status",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["Shield"].icon = CreateFrame("Frame","SAA_Bar5_StatusIcon",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["LavaLash"] = CreateFrame("Frame","SAA_Bar6_Status",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["LavaLash"].icon = CreateFrame("Frame","SAA_Bar6_StatusIcon",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["FeralSpirit"] = CreateFrame("Frame","SAA_Bar7_Status",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["FeralSpiritCD"] = CreateFrame("Frame","SAA_Bar7a_Status",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["FeralSpirit"].icon = CreateFrame("Frame","SAA_Bar7_StatusIcon",ShockAndAwe.BaseFrame)
ShockAndAwe.frames["GCD"] = CreateFrame("Frame", "SAA_Bar8_Status", ShockAndAwe.BaseFrame)
ShockAndAwe.msgFrame = CreateFrame("MessageFrame","ShockAndAweMsg",UIParent)

ShockAndAwe.textures = {}
ShockAndAwe.borders = {}
ShockAndAwe.fonts = {}
ShockAndAwe.sounds = {}
ShockAndAwe.barBackdrop = {
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}
ShockAndAwe.frameBackdrop ={
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	}
ShockAndAwe.GCDMin = 0
ShockAndAwe.GCDMax = 0
ShockAndAwe.GCDWidth = 0
	
local SSmin, SSmax, ShockMin, ShockMax, WFPMin, WFPMax, ShieldMin, ShieldMax, MaelstromMin, MaelstromMax, LLMin, LLMax, FSMin, FSMax,FSCDMin, FSCDMax
local updateActiveSS = false
local updateActiveMaelstrom = false
local updateActiveLavaLash = false
local updateActiveShock = false
local updateActiveShamanistic = false
local updateActiveWFProc = false
local updateActiveShield = false
local updateActiveFeralSpiritCD = false
local updateActiveGCD = false
local updatePriority = false
local WFProcTime = 0
local SSTime = 0
local GCDTime = 0
local LLTime = 0
local FSTime = 0
local FSCDTime = 0
local ShockTime = 0
local ShieldTime = 0
local lastSound = 0
local mw4played = false

-------------------
-- Config details
-------------------

ShockAndAwe.defaults = {
	char = {
		message = "Welcome Home!",
		barshow = true,
		showicons = true,
		relativeTo = "UIParent",
		relativePoint = "CENTER",
		point = "CENTER",
		texture = "Blizzard",
		barfont = "Friz Quadrata TT",
		barfontsize = 12,
		barfonteffect = "none",
		msgfont = "Friz Quadrata TT",
		msgfontsize = 24,
		msgfonteffect = "none",
		border = "None",
		barborder = "Blizzard Tooltip",
		mw4sound = "Sound\\Spells\\ShootWandLaunchLightning.wav",
		mw4soundname = "SAA Maelstrom 1",
		mw5sound = "Sound\\Spells\\DynamiteExplode.wav",
		mw5soundname = "SAA Maelstrom 2",
		shieldsound = "Sound\\Doodad\\BellowIn.wav",
		shieldsoundname = "SAA Shield 1",
		xOffset = 0,
		yOffset = 0,
		fWidth = 300,
		fHeight = 175,
		resetOn = true,
		scale = 1,
		ShockPercent = .6,
		shockshow = true,
		windshockshow = true,
		threatThreshold = 90,
		ssshow = true,
		wfshow = true,
		gcdshow = true,
		llshow = false,
		fsshow = true,
		disablebars = false,
		maelstromTalents = 0,
		lavaLashTalented = false,
		feralSpiritTalented = false,
		mw4soundplay = true,
		mw5soundplay = true,
		mw5repeat = 3,
		mwflash = true,
		shieldshow = true,
		activeshields = true,
		msshow = true,
		msstacks = 0,
		arena = false,
		barstext = true,
		SSlen = 10,
		LLlen = 6,
		ShockLen = 6,
		lastshock = "",
		debug = false,
		msg = { r = 1, g = .5, b = 0, },
		msgtime = 2,
		newsitem = 0,
		castweaponrebuff = false,
		colours = {
			watershield = { r=.6, g=.6,	b=1, a=.3 },
			lightningshield = { r=0, g=0, b=1, a=.5 },
			earthshield = { r=0, g=1, b=0, a=.5 },
			noshield = { r=1, g=0, b=0, a=1 },
			
			flameshock = { r=1, g=.6, b=.2, a=.9 },
			earthshock = { r=0, g=1, b=.3, a=.9	},
			frostshock = { r=.6, g=.6, b=1, a=.9 },
			windshock = { r=.6, g=.6, b=.6, a=.9 },
			
			maelstrom = { r=1, g=.5, b=1, a=.3 },
			msalpha = .3,
			msalphaFull = .9,

			lavalash = { r=1, g=.1, b=.1, a=.9 },
			feralspirit = { r=0, g=.6, b=.95, a=.9 },
			feralspiritCD = { r=0, g=.6, b=.95, a=.9 },
			stormstrike = { r=1, g=1, b=.2, a=.9 },
			windfury = { r=1, g=0, b=0, a=.5 },
		},
		uptime = {
			show = true,
			fWidth = 120,
			fHeight = 160,
			barWidth = 100,
			barHeight = 20,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			xOffset = 0,
			yOffset = -125,
			alpha = 0.4,
			scale = 1,
			flurry = { r = .2, g = .1, b = 1, a = 0.5, },
			ed = { r = 1, g = 1, b = .8, a = 0.5, },
			ur = { r = 1, g = .5, b = 0, a = 0.5, },
		},
		stats = {
			show = true,
			fWidth = 120,
			fHeight = 200,
			barWidth = 100,
			barHeight = 20,
			relativeTo = "self.UptimeFrame",
			relativePoint = "TOPLEFT",
			point = "TOPLEFT",
			xOffset = 125,
			yOffset = 0,
			alpha = 0.4,
			scale = 1,	
			wfcalc = true,
			wfcol = { r = 1, g = .5, b = 0, a = 0.5, },
			wftime = 2,
			best = {
				ap = 0,
				spellpower = 0,
				meleehit = 0,
				spellhit = 0,
				expertise = 0,
				meleecrit = 0,
				spellcrit = 0,
				wfmh = 0,
				wfoh = 0,
				stormstrike = 0,
			},
		},
		priority = {
			show = true,
			titleshow = true,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			fWidth = 50,
			fHeight = 50,
			xOffset = 50,
			yOffset = -50,
			alpha = 0.4,
			scale = 1,	
			next = 1,
			cooldown = 0.25,
			fstimeleft = 0.5,
			totemtimeleft = 20,
			srmana = 10,
			wsmana = 70,
			shieldorbs = 1,
			hwhealth = 45,
			chingroup = true,
			worldbossonly = true,
			combopoints = true,
			option = { "mw5_lb", "es_ss", "ss", "es", "ll", "none",},
		},
		binding = {
			show = true,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			fWidth = 200,
			fHeight = 50,
			xOffset = -200,
			yOffset = -100,
			alpha = 0.4,
			scale = 1,	
			mhspell = C["Windfury Weapon"],
			ohspell = C["Flametongue Weapon"],
			macroset = false,
		},
		warning = {
			show = true,
			duration = 3,
			shield = false,
			weapon = true,
			range = false,
			timeleft = 300, 
			colour = { r = 1, g = .5, b = 0, a = 0.5, },
			relativeTo = "UIParent",
			relativePoint = "TOP",
			point = "CENTER",
			fWidth = 400,
			fHeight = 75,
			xOffset = 0,
			yOffset = -250,
		},
	}
}

-----------------------------------------
-- Initialisation & Startup Routines
-----------------------------------------

function ShockAndAwe:OnInitialize()
	local AceConfigReg = LibStub("AceConfigRegistry-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")

	self.db = LibStub("AceDB-3.0"):New("ShockAndAweDBPC", ShockAndAwe.defaults, "char")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ShockAndAwe", self:GetOptions(), {"shockandawe", "saa"} )
	media.RegisterCallback(self, "LibSharedMedia_Registered")
	
	-- Add the options to blizzard frame (add them backwards so they show up in the proper order
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("ShockAndAwe","ShockAndAwe")
	self.optionsFrame[L["About"]] = LibStub("LibAboutPanel").new("ShockAndAwe", "ShockAndAwe")
	self.db:RegisterDefaults(self.defaults)
	self:InitialiseUptime()
	self:InitialiseBindings()
	self:CreateUptimeFrame()
	self:CreatePriorityFrame()
	self:CreateMsgFrame()
	self:News()
	local version = GetAddOnMetadata("ShockAndAwe","Version")
	self.version = ("ShockAndAwe v%s (r%s)"):format(version, REVISION)
	self:Print(self.version.." Loaded.")
end

function ShockAndAwe:OnDisable()
    -- Called when the addon is disabled
end

function ShockAndAwe:OnEnable()
	self:LibSharedMedia_Registered()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("UNIT_MANA")
	self:RegisterEvent("CHARACTER_POINTS_CHANGED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	self:RegisterEvent("UPDATE_BINDINGS")
	self:RegisterEvent("UI_ERROR_MESSAGE")
end

function ShockAndAwe:LibSharedMedia_Registered()
	media:Register("sound", "SAA Maelstrom 1", "Sound\\Spells\\ShootWandLaunchLightning.wav")
	media:Register("sound", "SAA Maelstrom 2", "Sound\\Spells\\DynamiteExplode.wav")
	media:Register("sound", "SAA Maelstrom 3", "Sound\\Spells\\ArmorKitBuffSound.wav")
	media:Register("sound", "SAA Maelstrom 4", "Sound\\Spells\\Fizzle\\FizzleShadowA.wav")
	media:Register("sound", "SAA Maelstrom 5", "Sound\\Spells\\LevelUp.wav")
	media:Register("sound", "SAA Maelstrom 6", "Sound\\Spells\\Tradeskills\\FishBite.wav")
	media:Register("sound", "SAA Maelstrom 7", "Sound\\Spells\\Tradeskills\\MiningHitA.wav")
	media:Register("sound", "SAA Maelstrom 8", "Sound\\Spells\\AspectofTheSnake.wav")
	media:Register("sound", "SAA Maelstrom 9", "Sound\\Spells\\bind2_Impact_Base.wav")
	media:Register("sound", "SAA Shield 1", "Sound\\Doodad\\BellowIn.wav")
	media:Register("sound", "SAA Shield 2", "Sound\\Doodad\\BellowOut.wav")
	media:Register("sound", "SAA Shield 3", "Sound\\Doodad\\PVP_Lordaeron_Door_Open.wav")
	media:Register("sound", "SAA Shield 4", "Sound\\Spells\\ShaysBell.wav")

	for k, v in pairs(media:List("statusbar")) do
		self.textures[v] = v
	end
	for k, v in pairs(media:List("border")) do
		self.borders[v] = v
	end
	for k, v in pairs(media:List("font")) do
		self.fonts[v] = v
	end
	for k, v in pairs(media:List("sound")) do
		self.sounds[v] = v
	end
end

----------------------
-- Event Routines
----------------------

function ShockAndAwe:UNIT_MANA()
	self:UpdateShieldBar()
end

function ShockAndAwe:PLAYER_ENTERING_WORLD()
	self:SetBorderTexture(nil, self.db.char.border)
	self:SetBarBorderTexture(nil, self.db.char.barborder)
	self:SetTalentEffects()
	self:RedrawFrames()
	self:UpdateBindings()
end

function ShockAndAwe:UNIT_AURA()
	if (arg1 == "player") then
		self:UpdateShieldBar()
		if self.db.char.msshow and self.db.char.maelstromTalents > 0 then
			updateActiveMaelstrom = true
			self.db.char.msstacks = self:GetMaelstromInfo()
			if self.db.char.barstext then
				self.frames["Maelstrom"].text:SetText(self.db.char.msstacks.." stacks")
			else 
				self.frames["Maelstrom"].text:SetText("")
			end
			self:MaelstromBar()
		end
	end
end

function ShockAndAwe:CHAT_MSG_SPELL_SELF_DAMAGE()
	if self.db.char.wfshow then
		if strfind(arg1, L["WF_Attack"]) then
			self:WFProcBar()
		end
	end
end

function ShockAndAwe:UI_ERROR_MESSAGE()
	if self.db.char.warning.range then
		if arg1 then self:DebugPrint("error message is :"..arg1) end
		if strfind(arg1, L["Out of range"]) or strfind(arg1, L["too far away"]) then
			self:PrintMsg(arg1, self.db.char.warning.colour, 0.5)
		end
	end
end

function ShockAndAwe:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	if sourceGUID == UnitGUID("player") then
		local spellID = select(1,...) or 0
		if spellID == self.combat.wf_mh or spellID == self.combat.wf_oh then 
			if self.db.char.wfshow then
				self:WFProcBar()
			end
		end
		if self.db.char.stats.wfcalc then
			if event == "SWING_DAMAGE" then
				self:WFCalc("melee", select(1,...), select(7,...), event, dstName, destFlags, destGUID)
			elseif event == "SWING_MISSED" then
				self:WFCalc("melee", select(5,...), nil, event)
			elseif event == "SPELL_DAMAGE" then
				self:WFCalc(spellID, select(4,...), select(10,...), event, dstName, destFlags, destGUID)
			elseif event == "SPELL_MISSED" then
				self:WFCalc(spellID, select(5,...), nil, event, dstName, destFlags, destGUID)
			end
		end
		if self.db.char.warning.shield and event == "SPELL_AURA_REMOVED" then
			if GetSpellInfo(spellID) == C["Lightning Shield"] or GetSpellInfo(spellID) == C["Water Shield"] then
				self:PrintMsg(GetSpellInfo(spellID).." "..L["Expired"], self.db.char.warning.colour, self.db.char.warning.duration)
				PlaySoundFile(self.db.char.shieldsound)
			end
		end
	end
	if destGUID == UnitGUID("player") and self.db.char.warning.weapon and not self.db.char.castweaponrebuff then
		if event == "ENCHANT_REMOVED" then
			if self:MainHandBuffMissing() or self:OffHandBuffMissing() then
				self:PrintMsg(L["Weapon Buff Expired"], self.db.char.warning.colour, self.db.char.warning.duration)
			end
		end
	end
end

function ShockAndAwe:SPELL_UPDATE_COOLDOWN()
	if self.db.char.gcdshow then
		self:GCDBar()
	end
end

function ShockAndAwe:UNIT_SPELLCAST_SUCCEEDED()
	if arg1 == "player" then -- skip if someone else casting
		if self.db.char.ssshow then
			if arg2 == C["Stormstrike"] then
				self:StormstrikeBar()
			end
		end
		if self.db.char.shieldshow then
			self:SetShieldType(arg2)
		end	
		if self.db.char.shockshow then
			if arg2 == C["Earth Shock"] then
				local colours = self.db.char.colours.earthshock
				self.db.char.lastshock = C["Earth Shock"]
				self:SetBarIcon(self.frames["Shock"].icon, 8042)
				self:ShockBar(colours)
			elseif arg2 == C["Flame Shock"] then
				local colours = self.db.char.colours.flameshock
				self.db.char.lastshock = C["Flame Shock"]
				self:SetBarIcon(self.frames["Shock"].icon, 8050)
				self:ShockBar(colours)
			elseif arg2 == C["Frost Shock"] then
				local colours = self.db.char.colours.frostshock
				self.db.char.lastshock = C["Frost Shock"]
				self:SetBarIcon(self.frames["Shock"].icon, 8056)
				self:ShockBar(colours)
			elseif arg2 == C["Wind Shock"] then
				local colours = self.db.char.colours.windshock
				self.db.char.lastshock = C["Wind Shock"]
				self:SetBarIcon(self.frames["Shock"].icon, 57994)
				self:ShockBar(colours)
			end
		end
		if self.db.char.llshow then
			if arg2 == C["Lava Lash"] then 
				self:LavaLashBar()
			end
		end
		if self.db.char.fsshow then
			if arg2 == C["Feral Spirit"] then 
				self:FeralSpiritBar()
			end
		end
		if arg2 == C["Windfury Weapon"] or arg2 == C["Flametongue Weapon"] or arg2 == C["Frostbrand Weapon"] then
			self.db.char.castweaponrebuff = true
		else
			self.db.char.castweaponrebuff = false
		end
	end
end

function ShockAndAwe:CHARACTER_POINTS_CHANGED()
	self:SetTalentEffects()
	self:CreateBaseFrame()
end

function ShockAndAwe:PLAYER_REGEN_DISABLED() -- Entering Combat
	if self.db.char.disablebars then
		self.BaseFrame:Show()
	end
	if self.db.char.msshow then
		self:SetMaelstromAlpha(self.db.char.colours.msalpha) -- set maelstrom frame to in combat alpha
	end
	if self.db.char.fsshow then
		FSMin, FSMax = self.frames["FeralSpirit"].statusbar:GetMinMaxValues()
		updateActiveFeralSpirit = true -- forces an update to check if puppies still available on re-entering combat
		self:FeralSpiritCDBar()
	end
	if self.db.char.uptime.show then
		if not self.uptime.incombat then
			self.uptime.incombat = true
			-- reset last fight data on entering combat
			self:InitialiseUptimeBuffs(self.uptime.lastfight)
			self.uptime.currentTime = GetTime()
			self:UpdateUptime()
			self:UpdateUptimeFrames(true)
			self.uptime.TimerEvent = self:ScheduleRepeatingTimer("UpdateUptime", 0.1, nil);
		end
	end
	if self.db.char.maelstromTalents == 0 then -- check MW talents again to counter Player_Entering_World bug
		self:SetTalentEffects()
		self:CreateBaseFrame()
	end
	if self.db.char.priority.show then
		self.db.char.priority.next = "none"
		self:SetPriorityIcon(self.db.char.priority.next)
		updatePriority = true
		self.PriorityFrame:Show()
	end
	if self.db.char.warning.weapon then
		if self:MainHandBuffMissing() or self:OffHandBuffMissing() then
			self:PrintMsg(L["Missing Weapon Buffs"], self.db.char.warning.colour, self.db.char.warning.duration)
		end
	end
	lastshock = ""
	updateShockIcon = true
end

function ShockAndAwe:PLAYER_REGEN_ENABLED() -- Leaving Combat
	self.frames["Maelstrom"]:Hide()
	self.frames["Maelstrom"].icon:Hide()
	self.frames["Shield"].icon:Hide()
	self.frames["Shock"].icon:Hide()
	self.frames["Stormstrike"].icon:Hide()
	self.frames["LavaLash"].icon:Hide()
	self:SetPriorityIcon("none")
	updatePriority = false
	self.PriorityFrame:Hide()
	if self.db.char.uptime.show then
		if self.uptime.incombat then
			self:UpdateUptime()
			self.uptime.incombat = false
			self:UpdateUptimeFrames(true)
			self:CancelTimer(self.uptime.TimerEvent , false)
		end
	end
	if self.db.char.fsshow then
		if not updateActiveFeralSpirit then 
			self.frames["FeralSpirit"].icon:Hide() -- out of combat hide icon if Feral spirits are not out
		end
		self.frames["FeralSpiritCD"]:Hide()
	end
	if self.db.char.disablebars then
		self.BaseFrame:Hide()
	end
	if not self.db.char.binding.macroset then
		-- call update Bindings to set macro keys if we were in combat when addon initialised
		self:UpdateBindings()
	end
end

function ShockAndAwe:PLAYER_TARGET_CHANGED()
	if InCombatLockdown() then
		updateShockIcon = true
	end
end

function ShockAndAwe:UPDATE_BINDINGS()
	self:UpdateBindings()
end

-------------------------
-- Shield bar routines
-------------------------

function ShockAndAwe:GetShieldInfo()
	local index = 1
	ShieldTime = 0
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, shieldExpires = UnitBuff("PLAYER", index)
		ShieldTime = shieldExpires
		if self:SetShieldType(name) then
			return count, name
		end
		index = index + 1
	end
	return 0, 0, ""
end

function ShockAndAwe:GetFlameShockInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, shockExpires, isMine = UnitDebuff("target", index)
		if name == C["Flame Shock"] and isMine then -- don't return true on finding another player's FS
			return true, shockExpires - GetTime()
		end
		index = index + 1
	end
	return false, 0
end

function ShockAndAwe:GetStormStrikeInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, isMine = UnitDebuff("target", index)
		if name == C["Stormstrike"] and isMine then -- don't return true on finding another player's FS
			return true, debuffExpires - GetTime()
		end
		index = index + 1
	end
	return false, 0
end

function ShockAndAwe:SetShieldType(name)
	local colours = self.db.char.colours;
	if name == C["Water Shield"] then
		self:ShieldBar(colours.watershield.r, colours.watershield.g, colours.watershield.b, colours.watershield.a)
		self:SetBarIcon(self.frames["Shield"].icon, 52127)
		return true
	elseif name == C["Lightning Shield"] then
		self:ShieldBar(colours.lightningshield.r, colours.lightningshield.g, colours.lightningshield.b, colours.lightningshield.a)
		self:SetBarIcon(self.frames["Shield"].icon, 324)
		return true
	elseif name == C["Earth Shield"] then
		self:ShieldBar(colours.earthshield.r, colours.earthshield.g, colours.earthshield.b, colours.earthshield.a)
		self:SetBarIcon(self.frames["Shield"].icon, 974)
		return true
	end
	return false
end	

function ShockAndAwe:UpdateShieldBar()
	if self.db.char.shieldshow then
		local orbs, shieldType = ShockAndAwe:GetShieldInfo()
		if orbs == 0 then
			updateActiveShield = false
			self.frames["Shield"].spark:Hide()
			self.frames["Shield"].statusbar:SetValue(600)
			if self.db.char.barstext then
				self.frames["Shield"].text:SetText("No Shield Active")
			else
				self.frames["Shield"].text:SetText("")
			end
		else
			updateActiveShield = true
			self.frames["Shield"].spark:Show()
			self.frames["Shield"].statusbar:SetValue(ShieldTime - GetTime())
			if self.db.char.barstext then
				self.frames["Shield"].text:SetText(orbs.." orbs remaining")
			else
				self.frames["Shield"].text:SetText("")
			end
		end
		if not updateActiveShield then
			local colours = self.db.char.colours;
			if UnitMana("player") == UnitManaMax("player") then
				-- shield down but at max mana
				self.frames["Shield"].statusbar:SetStatusBarColor(colours.noshield.r, colours.noshield.g, colours.noshield.b, .2)
				self.frames["Shield"]:SetBackdropBorderColor(1, 1, 1, .2);
			else 
				-- shield down but not at max mana
				self.frames["Shield"].statusbar:SetStatusBarColor(colours.noshield.r, colours.noshield.g, colours.noshield.b, 1)
				self.frames["Shield"]:SetBackdropBorderColor(1, 1, 1, 1);
			end
		end
		self.frames["Shield"].text:Show()
		self:SetShieldType(shieldType)
		if not self.db.char.activeshields and orbs > 0 then
			self.frames["Shield"]:Hide() -- hide frame if shield is active and option to show active fields is off
		else
			self.frames["Shield"]:Show()
		end 
	else
		self.frames["Shield"]:Hide()
	end
end

---------------------------
-- Buff Info functions
---------------------------

function ShockAndAwe:GetMaelstromInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, maelstromTime = UnitBuff("PLAYER", index)
		if name == C["Maelstrom Weapon"] then
			return count, maelstromTime
		end
		index = index + 1
	end
	return 0, 0 
end

---------------------------
-- functions
---------------------------

function ShockAndAwe:RedrawFrames()
	self:CreateBaseFrame()
	self:CreateUptimeFrame()
end

function ShockAndAwe:SetTalentEffects()
	local currRank, maxRank
	_, _, _, _, currRank, maxRank = GetTalentInfo(2,27)
	self.db.char.maelstromTalents = currRank
	_, _, _, _, currRank, maxRank = GetTalentInfo(2,22) -- lava lash
	if currRank == 0 then
		self.db.char.lavaLashTalented = false
	else
		self.db.char.lavaLashTalented = true	
	end
	_, _, _, _, currRank, maxRank = GetTalentInfo(2,23) 
	self.db.char.impSS = currRank
	_, _, _, _, currRank, maxRank = GetTalentInfo(1,6) 
	local reverberation = currRank
	if self.db.char.maelstromTalents == 0 then
		updateActiveMaelstrom = false
	end
	_, _, _, _, currRank, maxRank = GetTalentInfo(2,28)
	if currRank == 0 then
		self.db.char.feralSpiritTalented = false
	else
		self.db.char.feralSpiritTalented = true
	end
	 -- TODO replace this with programatic gear check if person has arena gear
	if self.db.char.arena then
		self.db.char.SSlen = 9 - self.db.char.impSS -- arena bonus reduces by 1 sec.
	else
		self.db.char.SSlen = 10 - self.db.char.impSS
	end
	self.db.char.SSPercent = 1 -- make Stormstrike bar full width
	self.db.char.LLPercent = self.db.char.LLlen / self.db.char.SSlen
	self.db.char.ShockLen = 6 - reverberation * 0.2
	self.db.char.ShockPercent = self.db.char.ShockLen / self.db.char.SSlen
	self.db.char.WFProcPercent = 3 / self.db.char.SSlen
end

function ShockAndAwe:DisplayVersion()
	self:Print(self.version)
end

function ShockAndAwe:CreateBaseFrame()
	if not self.db.char.SSPercent or not self.db.char.WFProcPercent or not self.db.char.ShockPercent then
		self:SetTalentEffects()
	end
	self.BaseFrame:SetScale(self.db.char.scale)
	self.BaseFrame:SetFrameStrata("BACKGROUND")
	self.BaseFrame:SetWidth(self.db.char.fWidth + self.db.char.fHeight / 7)
	self.BaseFrame:SetHeight(self.db.char.fHeight)
	self.BaseFrame:SetBackdrop(self.frameBackdrop)
	self.BaseFrame:SetBackdropColor(1, 1, 1, 0)
	self.BaseFrame:SetMovable(true)
	self.BaseFrame:RegisterForDrag("LeftButton")
	self.BaseFrame:SetPoint(self.db.char.point, self.db.char.relativeTo, self.db.char.relativePoint, self.db.char.xOffset, self.db.char.yOffset)
	self.BaseFrame:SetScript("OnDragStart", 
		function()
			self.BaseFrame:StartMoving();
		end );
	self.BaseFrame:SetScript("OnDragStop",
		function()
			self.BaseFrame:StopMovingOrSizing();
			self.BaseFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(self.db.char, self.BaseFrame);
		end );
	self.BaseFrame:Show()
	self.db.char.barshow = false
	
	local barHeight = self.db.char.fHeight / 7
	local baseOffset = (-1 * barHeight) + 3
	local barCount = 0
	local colours = self.db.char.colours.feralspiritCD
	ShockAndAwe:SetBarFrame(self.frames["FeralSpiritCD"], 
					self.db.char.fWidth, barHeight,
					barCount * baseOffset, 1,
					0, 180, 
					180, self.db.char.fWidth - 6,
					colours.r, colours.g, colours.b, colours.a,
					false)
	local colours = self.db.char.colours.feralspirit
	ShockAndAwe:SetBarFrame(self.frames["FeralSpirit"], 
					45/180 * self.db.char.fWidth, barHeight,
					barCount * baseOffset, 2,
					0, 45, 
					45, 1,
					colours.r, colours.g, colours.b, colours.a,
					true)
	if self.db.char.fsshow then
		barCount = barCount + 1 -- we will use feral spirit frame 
	end
	local colours = self.db.char.colours.noshield
	ShockAndAwe:SetBarFrame(self.frames["Shield"], 
					self.db.char.fWidth, barHeight,
					barCount * baseOffset, 1,
					0, 600, 
					600, self.db.char.fWidth - 6,
					colours.r, colours.g, colours.b, colours.a,
					true)
	if self.db.char.shieldshow then
		barCount = barCount + 1 -- we will use shield frame 
	end
	ShockAndAwe:SetBarFrame(self.frames["GCD"], 
					self.db.char.fWidth * 1.5 / self.db.char.SSlen, barHeight,
					barCount * baseOffset, 1,
					0, 1.5, 
					6, 1, 
					.6, .6, .6, .6,
					false)
	self.GCDWidth = self.frames["GCD"].statusbar:GetWidth() -- to account for spark width
	if self.db.char.gcdshow then
		barCount = barCount + 1 -- we will use gcd frame 
	end
	colours = self.db.char.colours.maelstrom
	ShockAndAwe:SetBarFrame(self.frames["Maelstrom"], 
					self.db.char.fWidth, barHeight,
					barCount * baseOffset, 1,
					0, 30, 
					6, 1, 
					colours.r, colours.g, colours.b, self.db.char.colours.msalpha,
					true)
	if self.db.char.msshow then
		barCount = barCount + 1 -- we will use maelstrom frame 
	end
	colours = self.db.char.colours.stormstrike
	ShockAndAwe:SetBarFrame(self.frames["Stormstrike"], 
					self.db.char.fWidth * self.db.char.SSPercent, barHeight, 
					barCount * baseOffset, 1,
					0, self.db.char.SSlen, 
					0.4, 0.4, 
					colours.r, colours.g, colours.b, colours.a,
					true)
	colours = self.db.char.colours.windfury
	ShockAndAwe:SetBarFrame(self.frames["Windfury"], 
					self.db.char.fWidth * self.db.char.WFProcPercent, barHeight, 
					barCount * baseOffset, 2,
					0, 3, 
					3, (self.db.char.fWidth * self.db.char.WFProcPercent - 6),
					colours.r, colours.g, colours.b, colours.a,
					false)
	if self.db.char.ssshow or self.db.char.wfshow then
		barCount = barCount + 1 
	end
	ShockAndAwe:SetBarFrame(self.frames["Shock"], 
					self.db.char.fWidth * self.db.char.ShockPercent, barHeight, 
					barCount * baseOffset, 1,
					0, self.db.char.ShockLen, 
					1, 0.8, 
					0, 1, .3, .9,
					true)
	if self.db.char.shockshow then
		barCount = barCount + 1
	end
	ShockAndAwe:SetBarFrame(self.frames["LavaLash"], 
					self.db.char.fWidth * self.db.char.LLPercent, barHeight, 
					barCount * baseOffset, 1,
					0, self.db.char.LLlen, 
					6, 1, 
					colours.r, colours.g, colours.b, colours.a,
					true)
	if self.db.char.llshow and self.db.char.lavaLashTalented then
		barCount = barCount + 1 -- we will use LavaLash frame 
	end
	self:SetBarIcon(self.frames["Stormstrike"].icon, 17364)
	self:SetBarIcon(self.frames["FeralSpirit"].icon, 51533)
	self:SetBarIcon(self.frames["LavaLash"].icon, 60103)
	self:SetBarIcon(self.frames["Maelstrom"].icon, 51528)
	self:UpdateShieldBar()
end

function ShockAndAwe:SetBarFrame(frameName, barWidth, barHeight, frameOffset, frameLevel, minValue, maxValue, frameValue, frameSpark, frameR, frameG, frameB, frameAlpha, icon)
	frameName:SetFrameStrata("LOW")
	frameName:SetWidth(barWidth)
	frameName:SetHeight(barHeight)
	frameName:ClearAllPoints()
	frameName:SetPoint("TOPLEFT", self.BaseFrame, "TOPLEFT", barHeight, frameOffset)
	frameName:SetBackdrop(self.barBackdrop);
	frameName:SetBackdropColor(0, 0, 0, .2);
	frameName:SetBackdropBorderColor( 1, 1, 1, 1);
	frameName:EnableMouse(false)
	if not frameName.statusbar then
		frameName.statusbar = CreateFrame("StatusBar", nil, frameName)
	end
	frameName.statusbar:SetFrameLevel(frameLevel)
	frameName.statusbar:ClearAllPoints()
	frameName.statusbar:SetHeight(barHeight - 6)
	frameName.statusbar:SetWidth(barWidth - 6)
	frameName.statusbar:SetPoint("TOPLEFT", frameName, "TOPLEFT", 3, -3)
	frameName.statusbar:SetStatusBarTexture(media:Fetch("statusbar", self.db.char.texture))
	frameName.statusbar:SetStatusBarColor(frameR, frameG, frameB, frameAlpha)
	frameName.statusbar:SetMinMaxValues(minValue,maxValue)
	frameName.statusbar:SetValue(frameValue)
	
	if not frameName.spark then
		frameName.spark = frameName.statusbar:CreateTexture(nil, "OVERLAY")
	end
	frameName.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frameName.spark:SetWidth(16)
	frameName.spark:SetHeight(barHeight + 16)
	frameName.spark:SetBlendMode("ADD")
	frameName.spark:SetPoint("CENTER",frameName.statusbar,"BOTTOMLEFT",(barWidth - 6)* frameSpark, -1)
	frameName.spark:Show()
	
	if not frameName.text then
		frameName.text = frameName:CreateFontString(nil,"OVERLAY")
	end
	local barfont = media:Fetch("font", self.db.char.barfont)
	frameName.text:SetFont(barfont, self.db.char.barfontsize, self.db.char.barfonteffect)
	frameName.text:ClearAllPoints()
	frameName.text:SetTextColor(1, 1, 1, 1)
	frameName.text:SetPoint("CENTER", frameName, "CENTER");
	frameName.text:SetText("")

	frameName:SetScript("OnUpdate", 
		function()
			OnUpdate();
		end );
	if icon then
		frameName.icon:SetWidth(barHeight - 3) -- same as height to get square box
		frameName.icon:SetHeight(barHeight - 3)
		frameName.icon:SetPoint("TOPRIGHT", frameName, "TOPLEFT", 0 , -2)
		frameName.icon:Hide()
	end	
	frameName:Hide()
end

function ShockAndAwe:SetBarIcon(iconFrame, spellID)
	local _, _, icon = GetSpellInfo(spellID)
	iconFrame:SetBackdrop({
		bgFile = icon,
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 0, right = 0, top = 0, bottom = 0 } })
end

function ShockAndAwe:ResetBars()
	self.BaseFrame:ClearAllPoints()
	self.db.char.point = self.defaults.char.point
	self.db.char.relativeTo = self.defaults.char.relativeTo 
	self.db.char.relativePoint = self.defaults.char.relativePoint
	self.db.char.xOffset = self.defaults.char.xOffset
	self.db.char.yOffset = self.defaults.char.yOffset
	self.db.char.fWidth = self.defaults.char.fWidth
	self.db.char.fHeight = self.defaults.char.fHeight
	self.db.char.scale = self.defaults.char.scale
	self.db.char.barfont = self.defaults.char.barfont
	self.db.char.barfontsize = self.defaults.char.barfontsize
	self.db.char.bartexture = self.defaults.char.bartexture
	self.db.char.texture = self.defaults.char.texture
	barshow = true
	self.BaseFrame:SetPoint(self.db.char.point, self.db.char.relativeTo, self.db.char.relativePoint, self.db.char.xOffset, self.db.char.yOffset)
	ShockAndAwe:SetTalentEffects()
	self:RedrawFrames()
	self.db.char.barshow = true -- so that call to ShowHideBars resets to false
	self:ShowHideBars()
	self:Print(L["config_reset"])
end

function ShockAndAwe:DebugTalents()
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		DEFAULT_CHAT_FRAME:AddMessage(GetTalentTabInfo(t)..":");
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			DEFAULT_CHAT_FRAME:AddMessage("- "..i..":"..nameTalent..": "..currRank.."/"..maxRank);
		end
	end
end

function ShockAndAwe:DebugFrameValues()
	self:Print("SSlen : "..self.db.char.SSlen)
	self:Print("SSPercent : "..self.db.char.SSPercent )
	self:Print("ShockLen : "..self.db.char.ShockLen)
	self:Print("ShockPercent : "..self.db.char.ShockPercent )
	self:Print("WFProcPercent : "..self.db.char.WFProcPercent)
end

function ShockAndAwe:WFProcBar()
	local colours = self.db.char.colours.windfury
	self.frames["Windfury"].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	self.frames["Windfury"]:Show()
	updateActiveWFProc = true
	WFProcTime = GetTime() + 3
	WFPMin, WFPMax = self.frames["Windfury"].statusbar:GetMinMaxValues()
end

function ShockAndAwe:ShieldBar(shieldR, shieldB, shieldG, shieldalpha)
	self.frames["Shield"].statusbar:SetStatusBarColor(shieldR, shieldB, shieldG, shieldalpha)
	self.frames["Shield"]:SetBackdropBorderColor( 1, 1, 1, shieldalpha);
	self.frames["Shield"].spark:Show()
	updateActiveShield = true
	ShieldMin, ShieldMax = self.frames["Shield"].statusbar:GetMinMaxValues()
	if self.db.char.showicons then
		self.frames["Shield"].icon:Show()
	else
		self.frames["Shield"].icon:Hide()
	end
end

function ShockAndAwe:MaelstromBar()
	local colours = self.db.char.colours.maelstrom
	self.frames["Maelstrom"].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, self.db.char.colours.msalpha)
	self.frames["Maelstrom"]:SetBackdropBorderColor( 1, 1, 1, self.db.char.colours.msalpha);
	self.frames["Maelstrom"].spark:Show()
	self.frames["Maelstrom"]:Show()
	updateActiveMaelstrom = true
	MaelstromMin, MaelstromMax = self.frames["Maelstrom"].statusbar:GetMinMaxValues()
	if self.db.char.showicons then
		self.frames["Maelstrom"].icon:Show()
	else
		self.frames["Maelstrom"].icon:Hide()
	end
end

function ShockAndAwe:StormstrikeBar()
	local colours = self.db.char.colours.stormstrike
	self.frames["Stormstrike"].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	self.frames["Stormstrike"]:Show()
	updateActiveSS = true
	SSTime = GetTime() + self.db.char.SSlen
	SSmin, SSmax = self.frames["Stormstrike"].statusbar:GetMinMaxValues()
	if self.db.char.showicons then
		self.frames["Stormstrike"].icon:Show()
	else
		self.frames["Stormstrike"].icon:Hide()
	end
end

function ShockAndAwe:LavaLashBar()
	local colours = self.db.char.colours.lavalash
	self.frames["LavaLash"].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	self.frames["LavaLash"]:Show()
	updateActiveLavaLash = true
	LLTime = GetTime() + self.db.char.LLlen
	LLMin, LLMax = self.frames["LavaLash"].statusbar:GetMinMaxValues()
	if self.db.char.showicons then
		self.frames["LavaLash"].icon:Show()
	else
		self.frames["LavaLash"].icon:Hide()
	end
end

function ShockAndAwe:FeralSpiritBar()
	local colours = self.db.char.colours.feralspirit
	self.frames["FeralSpirit"].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	self.frames["FeralSpirit"]:Show()
	updateActiveFeralSpirit = true
	FSTime = GetTime() + 45
	FSMin, FSMax = self.frames["FeralSpirit"].statusbar:GetMinMaxValues()	
	self:FeralSpiritCDBar()
end

function ShockAndAwe:FeralSpiritCDBar()
	if self.db.char.debug then
		self:Print("Feral Spirit CD Bar")
	end
	local colours = self.db.char.colours.feralspiritCD
	self.frames["FeralSpiritCD"].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	self.frames["FeralSpiritCD"]:Show()
	FSCDMin, FSCDMax = self.frames["FeralSpiritCD"].statusbar:GetMinMaxValues()
	updateActiveFeralSpiritCD = true  
	if self.db.char.showicons then
		self.frames["FeralSpirit"].icon:Show()
	else
		self.frames["FeralSpirit"].icon:Hide()
	end
end

function ShockAndAwe:ShockBar(colours)
	self.frames["Shock"].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	self.frames["Shock"]:Show()
	updateActiveShock = true
	updateShockIcon = true
	ShockTime = GetTime() + 6
	ShockMin, ShockMax = self.frames["Shock"].statusbar:GetMinMaxValues()
	if self.db.char.showicons then
		self.frames["Shock"].icon:Show()
	else
		self.frames["Shock"].icon:Hide()
	end
end

function ShockAndAwe:GCDBar()
	local startTime, duration, enabled = GetSpellCooldown(C["Lightning Shield"]) -- Lightning Shield chosen because it has no other cooldown and all shammys will have it
	duration = duration or 0 -- force nil to 0 if for some bizzare reason no LS available.
	if duration > 0 then 
		self.frames["GCD"]:Show()
		updateActiveGCD = true
		GCDTime = startTime + duration
		self.GCDMax = duration
	end
end

function ShockAndAwe:DurationString(duration)
    local string = (("%1.1f"):format(duration % 60)) .. "s";
    
    if (duration >= 60) then
        duration = floor(duration - (duration % 60)) / 60; -- minutes
        
        string = (duration % 60) .."m " .. string;
        
        if (duration >= 60) then
            duration = (duration - (duration % 60)) / 60; -- hours
            string = duration .. "h " .. string;
        end
    end
    return string
end

oldThreat = 0
oldThreatTime = GetTime()

function OnUpdate()
	if ShockAndAwe.db.char.debug then
		local isTanking, state, scaledPercent, rawPercent, threatValue = UnitDetailedThreatSituation("player", "target")
		if not state then state = 0 end
		if not scalePercent then scaledPercent = 0 end
		if not rawPercent then rawPercent = 0 end
		if not threatValue then threatValue = 0 end
		if threatValue ~= oldThreat then
			--ShockAndAwe:Print(("%1.2f"):format(GetTime() - oldThreatTime).."s - state :"..state.." scaled :"..("%1.2f"):format(100*scaledPercent).."% raw : "..rawPercent.."% - value :"..threatValue)
			oldThreat = threatValue
		end
	end
	
	local width = ShockAndAwe.db.char.fWidth - 6
	local timeLeft = 0
	if updateActiveMaelstrom then
		local maelstromTime
		ShockAndAwe.db.char.msstacks, maelstromTime = ShockAndAwe:GetMaelstromInfo()
		timeLeft = maelstromTime - GetTime()
		if ShockAndAwe.db.char.msstacks > 0 then
			ShockAndAwe:SetMaelstromAlpha(ShockAndAwe.db.char.colours.msalpha)
			ShockAndAwe.frames["Maelstrom"]:Show()
			if ShockAndAwe.db.char.showicons then
				ShockAndAwe.frames["Maelstrom"].icon:Show()
			end
		end
		if ShockAndAwe.db.char.msstacks ~= 4 then
			mw4played = false
		end
		if ShockAndAwe.db.char.msstacks == 5 then
			ShockAndAwe:SetMaelstromAlpha(ShockAndAwe.db.char.colours.msalphaFull)
			if ShockAndAwe.db.char.mw5flash then
				UIFrameFlash(ShockAndAwe.frames["Maelstrom"], 0.25, 0.25, 30, true, 0.25, 0.25)
			end
			if ShockAndAwe.db.char.mw5soundplay and InCombatLockdown() then
				if ShockAndAwe.db.char.mw5sound and lastSound < GetTime() - ShockAndAwe.db.char.mw5repeat then
					PlaySoundFile(ShockAndAwe.db.char.mw5sound)
					lastSound = GetTime()
				end
			end
		else
			UIFrameFlashRemoveFrame(ShockAndAwe.frames["Maelstrom"])
			ShockAndAwe:SetMaelstromAlpha(ShockAndAwe.db.char.colours.msalpha)
			if ShockAndAwe.db.char.msstacks == 4 and ShockAndAwe.db.char.mw4soundplay and not mw4played and InCombatLockdown() then
				PlaySoundFile(ShockAndAwe.db.char.mw4sound)
				mw4played = true
			end
		end		
		ShockAndAwe.frames["Maelstrom"].statusbar:SetValue(timeLeft)
		ShockAndAwe.frames["Maelstrom"].spark:SetPoint("CENTER",ShockAndAwe.frames["Maelstrom"].statusbar,"LEFT", timeLeft/30 * width,-1)
		if maelstromTime < GetTime() then
			UIFrameFlashRemoveFrame(ShockAndAwe.frames["Maelstrom"])
			ShockAndAwe:SetMaelstromAlpha(ShockAndAwe.db.char.colours.msalpha)
			ShockAndAwe.frames["Maelstrom"]:Hide()
			ShockAndAwe.frames["Maelstrom"].icon:Hide()
			updateActiveMaelstrom = false
		else
			ShockAndAwe.frames["Maelstrom"]:Show()
			if ShockAndAwe.db.char.showicons then
				ShockAndAwe.frames["Maelstrom"].icon:Show()
			end
		end		
	end
	if updateActiveSS then
		timeLeft = SSTime - GetTime()
		ShockAndAwe.frames["Stormstrike"].statusbar:SetValue(timeLeft)
		ShockAndAwe.frames["Stormstrike"].spark:SetPoint("CENTER",ShockAndAwe.frames["Stormstrike"].statusbar,"LEFT", timeLeft/SSmax * width * ShockAndAwe.db.char.SSPercent,-1)
		if SSTime < GetTime() then
			ShockAndAwe.frames["Stormstrike"]:Hide()
			ShockAndAwe.frames["Stormstrike"].icon:Hide()
			updateActiveSS = false
		end
	end
	if updateActiveGCD then
		timeLeft = GCDTime - GetTime()
		ShockAndAwe.frames["GCD"].statusbar:SetValue(timeLeft)
		local sparkpoint = timeLeft / 1.5 * ShockAndAwe.GCDWidth
		if sparkpoint > ShockAndAwe.GCDWidth then
			sparkpoint = ShockAndAwe.GCDWidth
		end
		ShockAndAwe.frames["GCD"].spark:SetPoint("CENTER",ShockAndAwe.frames["GCD"].statusbar,"LEFT", sparkpoint,-1)
		if GCDTime < GetTime() then
			ShockAndAwe.frames["GCD"]:Hide()
			updateActiveGCD = false
		end
	end
	if updateActiveLavaLash then
		timeLeft = LLTime - GetTime()
		ShockAndAwe.frames["LavaLash"].statusbar:SetValue(timeLeft)
		ShockAndAwe.frames["LavaLash"].spark:SetPoint("CENTER",ShockAndAwe.frames["LavaLash"].statusbar,"LEFT", timeLeft/LLMax * width * ShockAndAwe.db.char.LLPercent ,-1)
		if LLTime < GetTime() then
			ShockAndAwe.frames["LavaLash"]:Hide()
			ShockAndAwe.frames["LavaLash"].icon:Hide()
			updateActiveLavaLash = false
		end
	end
	if updateActiveShock then
		timeLeft = ShockTime - GetTime()
		ShockAndAwe.frames["Shock"].statusbar:SetValue(timeLeft)
		ShockAndAwe.frames["Shock"].spark:SetPoint("CENTER",ShockAndAwe.frames["Shock"].statusbar,"LEFT", timeLeft/ShockMax * width * ShockAndAwe.db.char.ShockPercent ,-1)
		if ShockTime < GetTime() then
			ShockAndAwe.frames["Shock"]:Hide()
			ShockAndAwe.frames["Shock"].icon:Hide()
			updateActiveShock = false
		end
	end
	if updateActiveShield then
		timeLeft = ShieldTime - GetTime()
		ShockAndAwe.frames["Shield"].statusbar:SetValue(timeLeft)
		ShockAndAwe.frames["Shield"].spark:SetPoint("CENTER",ShockAndAwe.frames["Shield"].statusbar,"LEFT", timeLeft/ShieldMax * width,-1)
		if ShieldTime < GetTime() then
			updateActiveShield = false
		end
	end
	if updateActiveFeralSpirit then
		timeLeft = FSTime - GetTime()
		ShockAndAwe.frames["FeralSpirit"].statusbar:SetValue(timeLeft)
		ShockAndAwe.frames["FeralSpirit"].spark:SetPoint("CENTER",ShockAndAwe.frames["FeralSpirit"].statusbar,"LEFT", timeLeft/FSMax * 45/180 * width,-1)
		if FSTime < GetTime() then
			ShockAndAwe.frames["FeralSpirit"]:Hide()
			if not InCombatLockdown() then
				ShockAndAwe.frames["FeralSpirit"].icon:Hide() -- hide icon if feral spirits expire and out of combat.
			end
			updateActiveFeralSpirit = false
		end
	end
	if updateActiveFeralSpiritCD then
		local startTime, duration, enabled = GetSpellCooldown(GetSpellInfo(51533)) 
		duration = duration or 0 -- force nil to 0 
		if duration > 0 then
			timeLeft = startTime + duration - GetTime()
			ShockAndAwe.frames["FeralSpiritCD"].statusbar:SetValue(timeLeft)
			ShockAndAwe.frames["FeralSpiritCD"].spark:SetPoint("CENTER",ShockAndAwe.frames["FeralSpiritCD"].statusbar,"LEFT", timeLeft/FSCDMax * width,-1)
		else
			-- set to full bar if expires
			ShockAndAwe.frames["FeralSpiritCD"].statusbar:SetValue(180)
			ShockAndAwe.frames["FeralSpiritCD"].spark:SetPoint("CENTER",ShockAndAwe.frames["FeralSpiritCD"].statusbar,"LEFT", 180/FSCDMax * width,-1)
			updateActiveFeralSpiritCD = false
		end
	end
	if updateActiveWFProc then
		timeLeft = WFProcTime - GetTime()
		ShockAndAwe.frames["Windfury"].statusbar:SetValue(timeLeft)
		ShockAndAwe.frames["Windfury"].spark:SetPoint("CENTER",ShockAndAwe.frames["Windfury"].statusbar,"LEFT", timeLeft/WFPMax * width * ShockAndAwe.db.char.WFProcPercent ,-1)
		if WFProcTime < GetTime() then
			ShockAndAwe.frames["Windfury"]:Hide()
			updateActiveWFProc = false
		end
	end
	if updatePriority then
		ShockAndAwe.db.char.priority.previous = ShockAndAwe.db.char.priority.next
		ShockAndAwe:SetNextPriority()
		if ShockAndAwe.db.char.priority.next ~= ShockAndAwe.db.char.priority.previous then
			ShockAndAwe:SetPriorityIcon(ShockAndAwe.db.char.priority.next)
		end
	end
end

function ShockAndAwe:CreateMsgFrame()
	self.msgFrame:ClearAllPoints()
	self.msgFrame:SetWidth(400)
	self.msgFrame:SetHeight(75)
	self.msgFrame:SetFrameStrata("BACKGROUND")
	self.msgFrame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 2, right = 2, top = 2, bottom = 2 }
	})
	self.msgFrame:SetBackdropColor(1, 1, 1, 0)
	self.msgFrame:SetMovable(true)
	self.msgFrame:RegisterForDrag("LeftButton")
	self.msgFrame:SetScript("OnDragStart", 
		function()
			self.msgFrame:StartMoving();
		end );
	self.msgFrame:SetScript("OnDragStop",
		function()
			self.msgFrame:StopMovingOrSizing();
			self.msgFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(self.db.char.warning, self.msgFrame);
		end );
	self.msgFrame:SetPoint(self.db.char.warning.point, self.db.char.warning.relativeTo, self.db.char.warning.relativePoint, self.db.char.warning.xOffset, self.db.char.warning.yOffset)
	self.msgFrame:SetInsertMode("TOP")
	self.msgFrame:SetFrameStrata("HIGH")
	self.msgFrame:SetToplevel(true)
	local font = media:Fetch("font", self.db.char.msgfont)
	self.msgFrame:SetFont(font, self.db.char.msgfontsize, self.db.char.msgfonteffect)
		
	self.msgFrame:Show()
end

function ShockAndAwe:PrintMsg(msg, col, time)
	if self.db.char.warning.show then
		if col == nil then
			col = { r=1, b=1, g=1, a=1 }
		end
		if time == nil then 
			time = 3
		end
		if time ~= 5 then
			self.msgFrame:SetTimeVisible(time)
		end
		self.msgFrame:AddMessage(msg, col.r, col.g, col.b, 1, col.time)
	end
end

function ShockAndAwe:DebugPrint(msg)
	if self.db.char.debug then
		self:Print(msg)
	end
end